#ifndef __CACHE_SLAB_H__
#define __CACHE_SLAB_H__

#include <utility/types.h>
#include <utility/list.h>
#include <page/page.h>
#include <i386/page.h>

struct Cache;

typedef enum
{
   SLAB_ALIGNMENT = I386_PAGE_ALIGNMENT,
   SLAB_SIZE      = I386_PAGE_SIZE
} SlabAttributes;

typedef struct
{
   ListNode objectList;
} Object;

typedef struct
{
   ListNode	  	slabList;
   Size			objectsAllocatedCount;
   List			objectsFree;
   PageAddress		page;
   struct Cache *	cache;
} Slab;

extern Bool     slab_create     (Slab **, struct Cache *);
extern void     slab_destroy    (Slab *);

#endif /* __CACHE_SLAB_H__ */

