#include <canvas/canvas.h>
#include <vga/context.h>
#include <utility/memory.h>
#include <scheduler/thread.h>

static void
canvasTest (void * data)
{
    VGAContext context;
    Canvas canvas;
    CanvasPoint a, b, c;
    CanvasArea d;
    canvas_create (& canvas, 320, 200, 8);

    vga_context_create (& context, VGA_MODE_IMAGE_320x200x8, NULL, NULL, NULL, NULL);
    vga_context_activate (& context);

    memory_zero (context.videoMemory, 320 * 200);
    
    a.x = 100;
    a.y = 100;

    b.x = 110;
    b.y = 110;

    c.x = 90;
    c.y = 115;

    d.x      = 120;
    d.y      = 120;
    d.width  = 20;
    d.height = 20;

    canvas_triangle (& canvas, 0x9, & a, & b, & c);
    canvas_rectangle (& canvas, 0xC, & d);
    canvas_line (& canvas, 0xA, & a, & b);
    canvas_line (& canvas, 0xC, & b, & c);
    canvas_line (& canvas, 0xF, & c, & a);

    memory_copy (context.videoMemory, canvas.pixels, 320 * 200);
}
    
Bool
__canvas_test_enter__ (void)
{
    return thread_create (NULL, THREAD_PRIORITY_MAXIMUM, THREAD_PRIORITY_MAXIMUM, canvasTest, NULL, NULL, 0);
}

