#ifndef __DEBUGGER_BREAKPOINT_H__
#define __DEBUGGER_BREAKPOINT_H__

#include <utility/types.h>
#include <utility/list.h>

typedef struct
{
        ListNode        breakPointList;
        Export *        function;
        uint8 *         address;
        uint8           code [2];
        Bool            isActivated;
} BreakPoint;

extern Bool     breakpoint_create       (BreakPoint **, const char *, const char *);
extern void     breakpoint_destroy      (BreakPoint *);

extern BreakPoint *     breakpoint_find_address         (uint8 *);
extern BreakPoint *     breakpoint_find_function        (const char *, const char *);

extern void     breakpoint_enable       (BreakPoint *);
extern void     breakpoint_disable      (BreakPoint *);

#endif /* __DEBUGGER_BREAKPOINT_H__ */
        
        
