%ifndef __I386_MANAGE_I__
%define __I386_MANAGE_I__

struc i386TaskStateSegment
	.backLink	resd	1
	.ESP_0		resd	1
	.SS_0		resd	1
	.ESP_1		resd	1
	.SS_1		resd	1
	.ESP_2		resd	1
	.SS_2		resd	1
	.CR3		resd	1
	.EIP		resd	1
	.EFLAGS		resd	1
	.EAX		resd	1
	.ECX		resd	1
	.EDX		resd	1
	.EBX		resd	1
	.ESP		resd	1
	.EBP		resd	1
	.ESI		resd	1
	.EDI		resd	1
	.ES		resd	1
	.CS		resd	1
	.SS		resd	1
	.DS		resd	1
	.FS		resd	1
	.GS		resd	1
	.LDTR		resd	1
	.debugTrap	resw	1
	.ioBitmap	resw	1
	.size
endstruc

I386_CR0_PROTECTION_ENABLE   equ (1 << 0)
I386_CR0_MONITOR_COPROCESSOR equ (1 << 1)
I386_CR0_EMULATION           equ (1 << 2)
I386_CR0_TASK_SWITCHED       equ (1 << 3)
I386_CR0_EXTENSION_TYPE      equ (1 << 4)
I386_CR0_NUMERIC_ERROR       equ (1 << 5)
I386_CR0_WRITE_PROTECT       equ (1 << 16)
I386_CR0_ALIGNMENT_MASK      equ (1 << 18)
I386_CR0_NOT_WRITE_THROUGH   equ (1 << 29)
I386_CR0_CACHE_DISABLE       equ (1 << 30)
I386_CR0_PAGING              equ (1 << 31)

I386_DESCRIPTOR_ATTRIBUTE_ACCESSED           equ 0x01 
I386_DESCRIPTOR_ATTRIBUTE_CODE               equ 0x08 
I386_DESCRIPTOR_ATTRIBUTE_NON_SYSTEM         equ 0x10 
I386_DESCRIPTOR_ATTRIBUTE_DPL                equ 0x60 
I386_DESCRIPTOR_ATTRIBUTE_PRESENT            equ 0x80 

I386_DESCRIPTOR_ATTRIBUTE_DPL_0              equ 0x00 
I386_DESCRIPTOR_ATTRIBUTE_DPL_1              equ 0x20 
I386_DESCRIPTOR_ATTRIBUTE_DPL_2              equ 0x40 
I386_DESCRIPTOR_ATTRIBUTE_DPL_3              equ 0x60 

I386_DESCRIPTOR_ATTRIBUTE_WRITE_ENABLE       equ 0x02 
I386_DESCRIPTOR_ATTRIBUTE_EXPAND_DOWN        equ 0x04 

I386_DESCRIPTOR_ATTRIBUTE_READ_ENABLE        equ 0x02 
I386_DESCRIPTOR_ATTRIBUTE_CONFORMING         equ 0x04 

I386_DESCRIPTOR_ATTRIBUTE_PAGE_GRANULARITY   equ 0x80 
I386_DESCRIPTOR_ATTRIBUTE_32_BIT             equ 0x40 

I386_DESCRIPTOR_ATTRIBUTE_TYPE               equ 0x0F 

I386_DESCRIPTOR_ATTRIBUTE_TYPE_286_TSS       equ 0x01 
I386_DESCRIPTOR_ATTRIBUTE_TYPE_286_TSS_BUSY  equ 0x03 
I386_DESCRIPTOR_ATTRIBUTE_TYPE_286_CALL_GATE equ 0x04 
I386_DESCRIPTOR_ATTRIBUTE_TYPE_286_INT_GATE  equ 0x06 
I386_DESCRIPTOR_ATTRIBUTE_TYPE_286_TRAP_GATE equ 0x07 

I386_DESCRIPTOR_ATTRIBUTE_TYPE_LDT           equ 0x02 
I386_DESCRIPTOR_ATTRIBUTE_TYPE_TASK_GATE     equ 0x05 
I386_DESCRIPTOR_ATTRIBUTE_TYPE_TSS           equ 0x09 
I386_DESCRIPTOR_ATTRIBUTE_TYPE_TSS_BUSY      equ 0x0B 
I386_DESCRIPTOR_ATTRIBUTE_TYPE_CALL_GATE     equ 0x0C 
I386_DESCRIPTOR_ATTRIBUTE_TYPE_INT_GATE      equ 0x0E
I386_DESCRIPTOR_ATTRIBUTE_TYPE_TRAP_GATE     equ 0x0F

I386_SELECTOR_TSS       		equ 0x0018
I386_SELECTOR_SYSTEM_CODE		equ 0x0020
I386_SELECTOR_SYSTEM_DATA		equ 0x0028
I386_SELECTOR_USER_CODE			equ 0x0030
I386_SELECTOR_USER_DATA			equ 0x0038

I386_GDT_OFFSET				equ 0x2000
I386_GDT_LIMIT				equ 256 * 8

I386_IDT_OFFSET				equ 0x2800
I386_IDT_LIMIT				equ 256 * 8

I386_TSS_OFFSET	        		equ 0x3000
I386_TSS_LIMIT  			equ 0x68

I386_STACK_OFFSET			equ 0x0000
I386_STACK_LIMIT			equ 8192

I386_STACK_INTERRUPT_OFFSET             equ 0x1000
I386_STACK_INTERRUPT_LIMIT              equ 4096

I386_STACK_EXCEPTION_OFFSET             equ 0x0000
I386_STACK_EXCEPTION_LIMIT              equ 4096

I386_MEMORY_OFFSET			equ 0x4000
I386_MEMORY_LIMIT			equ (~0 << 12) - I386_MEMORY_OFFSET + (1 << 12)

%endif

