#include <interrupt/irq.h>
#include <interrupt/exception.h>

Bool
exception_handler_create (ExceptionHandler * handler,
                          ExceptionNumber number,
                          ExceptionHandlerFunction * handlerFunction,
                          void * handlerData,
                          ExceptionHandlerPriority priority,
                          const char * name)
{
        handler -> handlerFunction = handlerFunction;
        handler -> handlerData     = (handlerData == NULL ? handler : handlerData);
        handler -> priority        = priority;
        handler -> name            = name;
        handler -> number          = IRQ_BASE_EXCEPTIONS + number;

        irq_handler_insert ((IRQHandler *) handler);

        return TRUE;
}

void
exception_handler_destroy (ExceptionHandler * handler)
{
        irq_handler_remove ((IRQHandler *) handler);
}

