#ifndef __INTERRUPT_EXCEPTION_H__
#define __INTERRUPT_EXCEPTION_H__

#include <utility/types.h>
#include <utility/list.h>

typedef uint32  ExceptionNumber;
typedef uint32  ExceptionParameter;
typedef SortKey ExceptionHandlerPriority;

typedef void ExceptionHandlerFunction (ExceptionNumber, 
                                       ExceptionParameter, 
                                       void *);

typedef struct
{
        ListKeyNode                     handlerList;
        ExceptionHandlerFunction *      handlerFunction;
        void *                          handlerData;
        ExceptionHandlerPriority        priority;
        const char *                    name;
        ExceptionNumber                 number;
} ExceptionHandler;

extern Bool exception_handler_create  (ExceptionHandler *,
                                       ExceptionNumber,
                                       ExceptionHandlerFunction *,
                                       void *,
                                       ExceptionHandlerPriority,
                                       const char *);
extern void exception_handler_destroy (ExceptionHandler *);

extern Size exception_level           (void);

#endif /* __INTERRUPT_EXCEPTION_H__ */

