%include "utility/assembly.i"
%include "i386/fpu.i"

section .text read nowrite exec contents

FUNCTION floor
        sub     esp, 4
        fnstcw  [esp]
        
        mov     eax, [esp]
        and     eax, ~ I386_FPU_ROUNDING_MASK
        or      eax, I386_FPU_ROUNDING_DOWN
        mov     [esp + 2], ax
        fldcw   [esp + 2]

        fld     qword [esp + 2 * 4]
        frndint
        
        fldcw   [esp]

        add     esp, 4
        ret
FUNCTION_END


FUNCTION ceil
        sub     esp, 4
        fnstcw  [esp]

        mov     eax, [esp]
        and     eax, ~ I386_FPU_ROUNDING_MASK
        or      eax, I386_FPU_ROUNDING_UP
        mov     [esp + 2], ax
        fldcw   [esp + 2]

        fld     qword [esp + 2 * 4]
        frndint

        fldcw   [esp]

        add     esp, 4
        ret
FUNCTION_END
        

FUNCTION sin
        fld     qword [esp + 4]
        fsin
        ret
FUNCTION_END


FUNCTION cos
        fld     qword [esp + 4]
        fcos
        ret
FUNCTION_END


FUNCTION sqrt
        fld     qword [esp + 4]
        fsqrt
        ret
FUNCTION_END


FUNCTION tan
        fld     qword [esp + 4]
        fptan
        fincstp
        ret
FUNCTION_END


FUNCTION fmod
        fld     qword [esp + 4 + 0 * 8]
        fld     qword [esp + 4 + 1 * 8]
        fprem1
        fstp    st1
        ret
FUNCTION_END


FUNCTION atan
        fld     qword [esp + 4]
        fld1
        fpatan
        ret
FUNCTION_END


FUNCTION atan2
        fld     qword [esp + 4 + 0 * 8]
        fld     qword [esp + 4 + 1 * 8]
        fpatan
        ret
FUNCTION_END


FUNCTION asin
        fld     qword [esp + 4]
        fld     st0
        fld     st0
        fmulp   st1
        fld1
        fsubrp  st1
        fpatan
        ret
FUNCTION_END


FUNCTION acos
        fld     qword [esp + 4]
        fld     st0
        fld     st0
        fmulp   st2
        fld1
        fsubrp  st2
        fpatan
        ret
FUNCTION_END


FUNCTION log
        fldln2
        fld     qword [esp + 4]
        fyl2x
        ret
FUNCTION_END

        
FUNCTION log10
        fldlg2
        fld     qword [esp + 4]
        fyl2x
        ret
FUNCTION_END


FUNCTION fabs
        fld     qword [esp + 4]
        fabs
        ret
FUNCTION_END
        

FUNCTION exp
        fld2le
        fld     qword [esp + 4]
        fmul    st1
        fst     st1
        frndint
        fxch
        fsub    st1
        f2xm1
        fld1
        faddp   st1
        fxch
        fscale
        faddp   st1
        ret
FUNCTION_END

        
FUNCTION pow
        fld1
        fld     qword [esp + 4 + 0 * 8]
        fyl2x
        fstp    st1
        fld     qword [esp + 4 + 1 * 8]
        fmul    st1
        fst     st1
        frndint
        fxch
        fsub    st1
        f2xm1
        fld1
        faddp   st1
        fxch
        fscale
        faddp   st1
        ret
FUNCTION_END

        
