#include <utility/string.h>
#include <utility/memory.h>
#include <memory/memory.h>
#include <libc/stdlib.h>

void *
memset (void * dst, int value, size_t length)
{
   return memory_set (dst, value, length);
}

void *
memcpy (void * dst, const void * src, size_t length)
{
   return memory_copy (dst, src, length);
}

void *
memmove (void * dst, const void * src, size_t length)
{
   return memory_move (dst, src, length);
}

void *
memchr (void * dst, int value, size_t length)
{
   return memory_find (dst, value, length);
}

int
memcmp (const void * dst, const void * src, size_t length)
{
   return memory_compare (dst, src, length);
}

size_t
strlen (const char * str)
{
   return string_length (str);
}

char *
strcpy (char * dst, const char * src)
{
   return string_copy (dst, ~0, src);
}

char *
strncpy (char * dst, const char * src, size_t length)
{
   return string_copy (dst, length, src);
}

char *
strchr (const char * dst, int c)
{
   while (* dst != (char) c &&
          * dst != '\0')
     ++ dst;

   if (* dst == (char) c)
     return (char *) dst;

   return NULL;
}

char *
strstr (const char * dst, const char * src)
{
   return string_find (dst, src);
}

int
strcmp (const char * dst, const char * src)
{
   return string_compare (dst, src);
}

char *
strdup (const char * src)
{
   return string_duplicate (src);
}
   
