#include <libc/time.h>
#include <libc/unistd.h>

void
usleep (unsigned long microSeconds)
{
   struct timespec tv;

   tv.tv_sec  = microSeconds / MICROSECONDS_PER_SECOND;
   tv.tv_nsec = (microSeconds % MICROSECONDS_PER_SECOND) * 1000;

   nanosleep (& tv, NULL);
}

unsigned
sleep (unsigned seconds)
{
   struct timespec requested, remaining;

   requested.tv_sec  = seconds;
   requested.tv_nsec = 0;

   if (nanosleep (& requested, & remaining) != 0)
     return seconds;

   return remaining.tv_sec + 
          (remaining.tv_nsec + NANOSECONDS_PER_SECOND - 1) / 
          NANOSECONDS_PER_SECOND;
}

int
select (int fdCount, 
        fd_set * readFds, 
        fd_set * writeFds, 
        fd_set * exceptFds, 
        struct timeval * timeout)
{
   struct timespec tv;

   if (timeout == NULL)
     return -1;

   if (timeout -> tv_sec <= 0 &&
       timeout -> tv_usec <= 0)
     return 0;

   tv.tv_sec  = timeout -> tv_sec;
   tv.tv_nsec = timeout -> tv_usec * 1000;

   nanosleep (& tv, NULL);

   if (readFds != NULL)
     FD_ZERO (readFds);

   if (writeFds != NULL)
     FD_ZERO (writeFds);

   if (exceptFds != NULL)
     FD_ZERO (exceptFds);

   return 0;
}

int
unlink (const char * file)
{
   return -1;
}

