#include <memory/memory.h>
#include <linker/component.h>
#include <linker/destructor.h>

Bool
destructor_create (Destructor ** result, Component * component, const char * name)
{
        Destructor * destructor = (Destructor *) memory_allocate (sizeof (Destructor));
        
        if (destructor == NULL)
          return FALSE;

        destructor -> name = name;

        list_insert_back (& component -> destructors, destructor);

        if (result != NULL)
          * result = destructor;

        return TRUE;
}

void
destructor_destroy (Destructor * destructor)
{
        list_remove (& destructor -> destructorList);

        memory_free (destructor);
}

