#include <memory/memory.h>
#include <linker/component.h>
#include <linker/section.h>
#include <linker/interface.h>
#include <linker/export.h>

Bool
export_create (Export ** result, Interface * interface, const char * name, Section * section, ExportType type, Address offset, Size size)
{
        Export * export = (Export *) memory_allocate (sizeof (Export));
        void ** values;

        if (export == NULL)
          return FALSE;

        export -> interface = interface;
        export -> name      = name;
        export -> section   = section;
        export -> type      = type;
        export -> offset    = offset;
        export -> size      = size;

        values = hash_table_insert (& section -> component -> exports, name);
        if (values == NULL)
        {
           memory_free (export);

           return FALSE;
        }

        * values = export;
        
        list_insert_back (& section -> exports, export);

        if (result != NULL)
          * result = export;

        return TRUE;
}

void
export_destroy (Export * export)
{
        if (export -> section != NULL)
        {
           list_remove (& export -> exportList);
          
           hash_table_remove (& export -> section -> component -> exports, export -> name);
        }

        memory_free (export);
}

