#ifndef __LINKER_EXPORT_H__
#define __LINKER_EXPORT_H__

#include <utility/list.h>

struct Section;
struct Interface;

typedef enum
{
        EXPORT_TYPE_UNKNOWN  = 0,
        EXPORT_TYPE_DATA     = 1,
        EXPORT_TYPE_FUNCTION = 2,
        EXPORT_TYPE_SECTION  = 3
} ExportType;

typedef struct Export
{
        ListNode           exportList;
        struct Interface * interface;
        const char *       name;
        struct Section *   section;
        ExportType         type;
        Address            offset; 
        Size               size;
} Export;

extern Bool     export_create   (Export **, struct Interface *, const char *, struct Section *, ExportType, Address, Size);
extern void     export_destroy  (Export *);

#endif /* __LINKER_EXPORT_H__ */

