#include <memory/memory.h>
#include <linker/component.h>

Bool
import_create (Import ** result, Component * component, const char * interface, const char * name, ImportType type)
{
        Import * import = (Import *) memory_allocate (sizeof (Import));

        if (import == NULL)
          return FALSE;

        import -> interface       = interface;
        import -> name            = name;
        import -> type            = type;
        import -> export          = NULL;
        import -> relocationCount = 0;

        list_insert_back (& component -> imports, import);

        if (result != NULL)
          * result = import;

        return TRUE;
}

void
import_destroy (Import * import)
{
        list_remove (& import -> importList);

        memory_free (import);
}

