#ifndef __LINKER_RELOCATION_H__
#define __LINKER_RELOCATION_H__

#include <utility/types.h>

struct Import;
struct Section;

typedef enum
{
        RELOCATION_TYPE_I386_ABSOLUTE_16 = 1,
        RELOCATION_TYPE_I386_ABSOLUTE_32 = 2,
        RELOCATION_TYPE_I386_RELATIVE_8  = 3,
        RELOCATION_TYPE_I386_RELATIVE_16 = 4,
        RELOCATION_TYPE_I386_RELATIVE_32 = 5
} RelocationType;

typedef struct Relocation
{
        RelocationType  type;
        struct Import * import;
        Address         offset;
        Address         addend;
} Relocation;

extern Bool     relocation_create       (Relocation *, RelocationType, Import *, Address, Address);

extern void     relocation_relocate     (Relocation *, struct Section *);

#endif /* __LINKER_RELOCATION_H__ */

