#ifndef __MEMORY_ALLOCATOR_H__
#define __MEMORY_ALLOCATOR_H__

#include <cache/cache.h>

typedef struct
{
	Cache		caches [SLAB_ALIGNMENT];
} MemoryAllocator;

extern Bool	memory_allocator_create 	(MemoryAllocator *);
extern void	memory_allocator_destroy 	(MemoryAllocator *);

extern void *   memory_allocator_allocate_within (MemoryAllocator *, void *, void *, Size);
extern void *	memory_allocator_allocate	(MemoryAllocator *, Size);
extern void	memory_allocator_claim		(MemoryAllocator *, void *, Size);
extern void	memory_allocator_release	(MemoryAllocator *, void *, Size);
extern void *	memory_allocator_resize		(MemoryAllocator *, void *, Size);
extern void	memory_allocator_free		(MemoryAllocator *, void *);
extern Size	memory_allocator_size		(MemoryAllocator *, void *);

#endif /* __MEMORY_ALLOCATOR_H__ */


