#include <pci/bios32.h>
#include <pci/bios.h>

PCIBios32ServiceDirectory *
pci_bios32_find_service_directory (void)
{
   PCIBios32ServiceDirectory * offset, * limit;
   

   offset = (PCIBios32ServiceDirectory *) PCI_BIOS32_SERVICE_DIRECTORY_OFFSET;
   limit  = (PCIBios32ServiceDirectory *) PCI_BIOS32_SERVICE_DIRECTORY_LIMIT;

   while (offset < limit)
   {
      if (offset -> signature == PCI_BIOS32_SERVICE_DIRECTORY_SIGNATURE)
      {
	 uint8 checksum = 0;
         uint8 * memory = (uint8 *) offset;
	 Size remaining = sizeof (PCIBios32ServiceDirectory);

	 while (remaining > 0)
         {
            checksum += * memory;
            ++ memory;
	    -- remaining;
	 }

	 if (checksum == 0)
           break;
      }

      ++ offset;
   }

   if (offset >= limit)
     return NULL;

   return offset;
}

