#ifndef __PCI_PCI_H__
#define __PCI_PCI_H__

#include <utility/types.h>

typedef uint16	PCIBusNumber;
typedef uint16	PCIDeviceNumber;
typedef uint8	PCIRegisterNumber;
typedef uint16	PCIDeviceID;
typedef uint16	PCIVendorID;
typedef uint32	PCIClassCode;

enum
{
	PCI_DEVICE_ID_ANY = (1 << 16) - 1
};

enum
{
	PCI_VENDOR_ID_ANY = (1 << 16) - 1
};

enum
{
	PCI_BUS_NUMBER_MAXIMUM = (1 << 8) - 1
};

enum
{
	PCI_DEVICE_NUMBER_MAXIMUM = (1 << 8) - 1
};

typedef enum
{
	PCI_CONFIGURATION_VENDOR_ID           = 0x00,
	PCI_CONFIGURATION_DEVICE_ID           = 0x02,
	PCI_CONFIGURATION_COMMAND             = 0x04,
	PCI_CONFIGURATION_STATUS              = 0x06,
	PCI_CONFIGURATION_REVISION_ID         = 0x08,
	PCI_CONFIGURATION_CLASS_CODE          = 0x08,
	PCI_CONFIGURATION_CACHE_LINE_SIZE     = 0x0C,
	PCI_CONFIGURATION_LATENCY_TIMER       = 0x0D,
	PCI_CONFIGURATION_HEADER_TYPE         = 0x0E,
	PCI_CONFIGURATION_BIST                = 0x0F,
	PCI_CONFIGURATION_BASE_ADDRESS_0      = 0x10,
	PCI_CONFIGURATION_BASE_ADDRESS_1      = 0x14,
	PCI_CONFIGURATION_BASE_ADDRESS_2      = 0x18,
	PCI_CONFIGURATION_BASE_ADDRESS_3      = 0x1C,
	PCI_CONFIGURATION_BASE_ADDRESS_4      = 0x20,
	PCI_CONFIGURATION_BASE_ADDRESS_5      = 0x24,
	PCI_CONFIGURATION_CARDBUS_CIS         = 0x28,
	PCI_CONFIGURATION_SUBSYSTEM_VENDOR_ID = 0x2C,
	PCI_CONFIGURATION_SUBSYSTEM_DEVICE_ID = 0x2A,
	PCI_CONFIGURATION_ROM_ADDRESS         = 0x30,
	PCI_CONFIGURATION_CAPABILITY_LIST     = 0x34,
	PCI_CONFIGURATION_INTERRUPT_LINE      = 0x3C,
	PCI_CONFIGURATION_INTERRUPT_PIN       = 0x3D,
	PCI_CONFIGURATION_MINIMUM_GNT	      = 0x3E,
	PCI_CONFIGURATION_MAXIMUM_LAT	      = 0x3F
} PCIConfiguration;

#endif /* __PCI_PCI_H__ */

