#ifndef __SCHEDULER_CONDITION_H__
#define __SCHEDULER_CONDITION_H__

#include <timer/timer.h>
#include <scheduler/spinlock.h>
#include <scheduler/mutex.h>

typedef struct
{
        Spinlock        lock;
	List            waitingThreads;
} Condition;

extern Bool condition_create 	(Condition *);
extern void condition_destroy	(Condition *);

extern Bool condition_wait	 (Condition *, Mutex *);
extern Bool condition_timed_wait (Condition *, Mutex *, TimeOffset *);
extern Bool condition_signal	 (Condition *);
extern Size condition_broadcast	 (Condition *);

#endif /* __SCHEDULER_CONDITION_H__ */

