#ifndef __SCHEDULER_MUTEX_H__
#define __SCHEDULER_MUTEX_H__

#include <timer/timer.h>
#include <scheduler/spinlock.h>

struct Thread;

typedef struct
{
        Spinlock        lock;
	struct Thread * owner;
	Size            depth;
        List            waitingThreads;
} Mutex;

extern Bool mutex_create 	(Mutex *);
extern void mutex_destroy	(Mutex *);

extern Size mutex_lock		(Mutex *);
extern Size mutex_timed_lock    (Mutex *, TimeOffset *);
extern Size mutex_try_lock	(Mutex *);
extern Size mutex_unlock	(Mutex *);

#endif /* __SCHEDULER_MUTEX_H__ */

