#ifndef __SCHEDULER_SCHEDULER_H__
#define __SCHEDULER_SCHEDULER_H__

#include <utility/types.h>
#include <utility/list.h>
#include <timer/timer.h>
#include <scheduler/thread.h>

enum
{
        IDLE_THREAD_STACK_SIZE = 256
};

typedef struct Scheduler
{
	List		       priorities [THREAD_PRIORITY_EXCLUSIVE - THREAD_PRIORITY_IDLE + 1];
	List *		       priorityCurrent;
	Thread *	       threadCurrent;
	Timer		       timer;
} Scheduler;

extern Bool		scheduler_create	(Scheduler *);
extern Bool		scheduler_prioritize	(Scheduler *);
extern Bool		scheduler_preempt	(Scheduler *, ThreadPriority);

extern Scheduler *      scheduler_current       (void);

extern Thread *         scheduler_choose        (Scheduler *);
extern void             scheduler_yield         (Scheduler *, Thread *);

#endif /* __SCHEDULER_SCHEDULER_H__ */

