#include <console/console.h>
#include <scheduler/thread.h>
#include <scheduler/critical.h>

static Thread * printThread = NULL;

static void
fooFunction (void * data)
{
   while (TRUE)
   {
     critical_enter ();

     if (printThread != thread_current ())
       console_print_format (NULL,
                             "%x: %x (fooFunction), %x (%s), %s\n", 
		             thread_current (), 
	 		     thread_current () -> enterFunction,
 			     thread_current () -> enterData,
			     thread_current () -> enterData,
			     data);

     printThread = thread_current ();
     
     critical_exit ();
   }
}

static void
barFunction (void * data)
{
   while (TRUE)
   {
     critical_enter ();

     if (printThread != thread_current ())
       console_print_format (NULL, "%x: %x (barFunction), %x (%s), %s\n", 
		             thread_current (), 
		 	     thread_current () -> enterFunction,
			     thread_current () -> enterData,
			     thread_current () -> enterData,
			     data);

     printThread = thread_current ();

     critical_exit ();
   }
}

Bool
__test_enter__ (void)
{
    if (thread_create (NULL, THREAD_PRIORITY_MINIMUM + 1, THREAD_PRIORITY_MAXIMUM, fooFunction, "foo", NULL, 0) == FALSE)
      console_print (NULL, "test: thread_create (\"foo\") failed!");
    
    if (thread_create (NULL, THREAD_PRIORITY_MINIMUM + 1, THREAD_PRIORITY_MAXIMUM, barFunction, "bar", NULL, 0) == FALSE)
      console_print (NULL, "test: thread_create (\"bar\") failed!");

    return TRUE;
}

