#ifndef __TIMER_TIME_OFFSET_H__
#define __TIMER_TIME_OFFSET_H__

#include <utility/types.h>

typedef Size    Seconds;
typedef Size    MilliSeconds;
typedef Size    NanoSeconds;
typedef Size    MicroSeconds;

enum
{
        MILLISECONDS_PER_SECOND = 1000,
        MICROSECONDS_PER_SECOND = 1000 * MILLISECONDS_PER_SECOND,
        NANOSECONDS_PER_SECOND  = 1000 * MICROSECONDS_PER_SECOND
};

typedef struct
{
        Seconds         seconds;
        NanoSeconds     nanoSeconds;
} TimeOffset;

extern void	time_offset_add		(TimeOffset *, const TimeOffset *);
extern void	time_offset_subtract	(TimeOffset *, const TimeOffset *);
extern void     time_offset_normalize   (TimeOffset *);

#endif /* __TIMER_TIME_OFFSET_H__ */

