#ifndef __TIMER_TIMER_H__
#define __TIMER_TIMER_H__

#include <utility/types.h>
#include <utility/list.h>
#include <timer/time_offset.h>

enum
{
	TIMER_HZ     = 100,
        TIMER_PERIOD = NANOSECONDS_PER_SECOND / TIMER_HZ
};

struct Timer;

typedef void TimerHandler (struct Timer *, void *);

typedef struct Timer
{
	ListNode	timerList;
	TimeOffset	timeDeadline;
	TimeOffset	timeOffset;
	TimerHandler *	handlerFunction;
	void *		handlerData;
	Bool		isPeriodic;
} Timer;

extern Bool	timer_create	(Timer *, const TimeOffset *, TimerHandler *, void *, Bool);
extern void	timer_destroy	(Timer *);

extern void     timer_check     (void);
extern void     timer_activate  (Timer *);

extern Bool 	timer_start	(Timer *);
extern Bool	timer_stop	(Timer *, TimeOffset *);
extern Bool	timer_reset	(Timer *, TimeOffset *);

#endif /* __TIMER_TIMER_H__ */

