#include <utility/list.h>

ListIterator	
list_insert_vector (ListIterator position, void * first, void * boundary, Size stride)
{
   uint8 * current  = (uint8 *) first,
         * last     = (uint8 *) boundary - stride;
   ListIterator end = position;
 
   if (current > last)
     return end;

   position = list_previous (end);

   for (position -> next = (ListNode *) first;
        current <= last;
	current += stride)
   {
      ((ListNode *) current) -> previous = (ListNode *) (current - stride);
      ((ListNode *) current) -> next     = (ListNode *) (current + stride);
   }

   end -> previous              = (ListNode *) (current - stride);
   end -> previous -> next      = end;
   position -> next -> previous = position;
   
   return list_next (position);
}
   
