BOOT=`grep -v '#' boot.txt | awk '{ printf "components/%s.xcom\n", $1, ".xcom" }'`

echo "Component: boot.xcom"
for X in ${BOOT};
do
   echo "  Boot component:" $X
done

./pidl -m -i components/ boot.pcom boot boot.pi

#./interface boot.interface boot `grep -v '#' boot.txt`

./xl -mzse -i boot.pcom@pos boot.xcom ${BOOT}

#Get a rough estimate of the offset of the sections in the xcom.
./xl -m -a 0x100000 image.tail boot.xcom

TEXT=`./offset image.tail ".text" 0x100000`
DATA=`./offset image.tail ".data" 0x100000`
BSS=`./offset image.tail ".bss" 0x100000`
RODATA=`./offset image.tail ".rodata" 0x100000`

# Create the final xcom.
echo "Making image.pos"
echo "Text:" 0x$TEXT "Data:" 0x$DATA "Bss:" 0x$BSS "Rodata:" 0x$RODATA

./xl -m -a 0x$TEXT@.text -a 0x$DATA@.data -a 0x$BSS@.bss -a 0x$RODATA@.rodata image.tail boot.xcom

BOOT_INFORMATION=`./symval image.tail boot_information`
START_ADDRESS=`./symval image.tail _start`

for M in `grep -v '#' modules.txt`;
do
   echo "Component:" $M.xcom

   cat image.tail components/$M.xcom > image.tmp
   cp image.tmp image.tail
   rm image.tmp
done

IMAGE_SIZE=`./size image.tail`

echo "Size:" $IMAGE_SIZE "Load:" 0x100000 "Start:" 0x$START_ADDRESS "Information:" 0x$BOOT_INFORMATION

./header image.head $IMAGE_SIZE 0x100000 0x$START_ADDRESS 0x$BOOT_INFORMATION
cat image.head image.tail > image.pos


