#ifndef __PIDL_COMPONENT_H__
#define __PIDL_COMPONENT_H__

#include "list.h"

typedef struct
{
        const char *    name;
        List            exports;
        List            imports;
        List            constructors;
        List            destructors;
} Component;

extern Component *      component_create        (const char *);
extern void             component_destroy       (Component *);

extern int              component_include       (Component *, Component *);
extern void             component_prune         (Component *);

#endif /* __PIDL_COMPONENT_H__ */

