#include <string.h>
#include "definition.h"

Definition *
definition_create (List * list, size_t offset, const char * name)
{
     Definition * definition = (Definition *) malloc (sizeof (Definition) + strlen (name));

     if (definition == NULL)
       return NULL;

     definition -> offset          = offset;
     definition -> interface       = NULL;
     definition -> component       = NULL;

     strcpy (definition -> name, name);

     if (list != NULL)
       list_insert_back (list, & definition -> definitionList);

     return definition;
}

void
definition_destroy (Definition * definition)
{
     list_remove (& definition -> definitionList);

     if (definition -> interface != NULL)
       interface_destroy (definition -> interface);

     if (definition -> component != NULL)
       component_destroy (definition -> component);

     free (definition);
}

