#ifndef __PIDL_VALUE_H__
#define __PIDL_VALUE_H__

#include <stdarg.h>
#include <stdio.h>
#include "list.h"
#include "llexer.h"

typedef enum
{
        VALUE_TYPE_INTEGER = 0,
        VALUE_TYPE_STRING  = 1,
        VALUE_TYPE_LIST    = 2
} ValueType;

typedef union
{
        int    integer;
        char * string;
        List   list;
} ValueDatum;

typedef struct
{
        ListNode        valueList;
        ValueType       type;
        ValueDatum      datum;
} Value;

extern Value *  value_create    (ValueType);
extern void     value_destroy   (Value *);

extern Value *  value_copy      (Value *);

extern Value *  value_read      (LLexer *);
extern Value *  value_read_list (LLexer *);

extern int      value_match_list (Value *, const char *, va_list);
extern int      value_match      (Value *, const char *, ...);

extern void     value_write      (Value *, FILE *);

#endif /* __PIDL_VALUE_H__ */

