#include <string.h>
#include "symbol.h"
#include "definition.h"

Definition *
definition_create (List * list, size_t offset, const char * name, struct Symbol * symbol)
{
     Definition * definition = (Definition *) malloc (sizeof (Definition) + strlen (name));

     if (definition == NULL)
       return NULL;

     definition -> offset          = offset;
     definition -> symbol          = symbol;
     definition -> referenceCount  = 0;
     definition -> relocationCount = 0;

     strcpy (definition -> name, name);

     if (list != NULL)
       list_insert_back (list, & definition -> definitionList);

     return definition;
}

void
definition_destroy (Definition * definition)
{
     list_remove (& definition -> definitionList);

     free (definition);
}

void
definition_reference (Definition * definition)
{
     ++ definition -> referenceCount;
}

void
definition_dereference (Definition * definition)
{
     -- definition -> referenceCount;

     if (definition -> referenceCount <= 0)
       definition_destroy (definition);
}

