#ifndef __XL_DEFINITION_H__
#define __XL_DEFINITION_H__

#include <stdlib.h>
#include <string.h>
#include "list.h"

typedef struct
{
        ListNode        definitionList;
        size_t          offset;
        struct Symbol * symbol;
        size_t          referenceCount;
        size_t          relocationCount;
        char            name [1];
} Definition;

extern Definition *     definition_create       (List *, size_t, const char *, struct Symbol *);
extern void             definition_destroy      (Definition *);

extern void             definition_reference    (Definition *);
extern void             definition_dereference  (Definition *);

#endif /* __XL_DEFINITION_H__ */

