#include <stdlib.h>
#include "error.h"

static int verboseMessages = 0;

void
xl_print (FILE * file, const char * format, va_list arguments)
{
       fprintf (file, "xl: ");

       vfprintf (file, format, arguments);

       fputc ('\n', file);
}

void
xl_verbose (int verbose)
{
       verboseMessages = verbose;
}

void
xl_message (const char * format, ...)
{
       va_list arguments;

       if (verboseMessages != 0)
       {
           va_start (arguments, format);

           xl_print (stdout, format, arguments);

           va_end (arguments);
       }
}

void
xl_warning (const char * format, ...)
{
       va_list arguments;

       va_start (arguments, format);

       xl_print (stderr, format, arguments);

       va_end (arguments);
}

void
xl_error (const char * format, ...)
{
       va_list arguments;

       va_start (arguments, format);

       xl_print (stderr, format, arguments);

       va_end (arguments);

       exit (EXIT_FAILURE);
}

